///////////////////////////////////////////////////
//Beispiel Kapitel Turtlegrafik
//Schneeflocke mit LSystem
//Achten Sie auf die Ausgabe in der Konsole!
//////////////////////////////////////////////////

// Zustand der Turtle
boolean penIsDown; // Stift is unten (es wird gemalt)

// gloable Variablen: 
// Fenstergröße
int w=750;
int h=750;
float laenge = 512;
float delta = 60;
int tiefe = 1;

// die Beschreibungssprache

String axiom = "F";
String substitut = "F+F--F+F";
String s = axiom;


///////////////////////////////////////////////////////////

void settings() {
  size(w, h);
}

void setup() {
  ersetzeBuchstaben();
  noLoop();
  redraw();
}


///////////////////////////////////////////////////////////
// Erzeuge eine Zeichenkette, die die Schneeflocke 
// beschreibt. Hierbei werden von "axiom" aufgehend
// alle "F" in der Zeichenkette durch "substitut" ersetzt
///////////////////////////////////////////////////////////

void ersetzeBuchstaben() {
  
  s = axiom;
  // ersetze alle "F" in s durch das Substitut
  for (int i=0; i<tiefe; i++) {
     s = s.replaceAll("F",substitut);
     println(s);
  }
}

///////////////////////////////////////////////////////////

void draw() {
  background(255);
  translate(30,height-30); 
  strokeWeight(2);
  setColor(color(255,0,0));
  penDown();
  laenge = (0.9*width)/pow(3, tiefe);

  // jetzt interpretiere die mit "applySubstitutions()"
  // erzeugte Zeichenkette
  
  for (int i=0;i<s.length();i++) {
    char c = s.charAt(i);
    switch (c) {
      case 'F': move(laenge);
                break;
      case '+': turn(delta);
                break;
      case '-': turn(-delta);
                break;
    }  
  }
}

///////////////////////////////////////////////////////////

void keyPressed() {
  if (key == '+') {
      tiefe = min(10,tiefe+1);
      ersetzeBuchstaben();
      redraw();
  }
  if (key == '-') {
      tiefe = max(1,tiefe-1);
      ersetzeBuchstaben();
      redraw();
  }
}

///////////////////////////////////////////////////////////
//
// Turtle Kommandos
//
///////////////////////////////////////////////////////////

void move(float len) {
  if (penIsDown) line(0,0,len,0);
  // bewege Turtle weiter
  translate(len,0);
}

void turn(float ang) { rotate(radians(-ang)); }
void setColor(color c) { stroke(c); }
void penUp() { penIsDown = false; }
void penDown() { penIsDown = true; }